import org.objectweb.joram.client.jms.tcp.TcpConnectionFactory;

import javax.jms.ConnectionFactory;
import javax.jms.Connection;
import javax.jms.Session;
import javax.jms.Queue;
import javax.jms.MessageProducer;
import javax.jms.MessageConsumer;
import javax.jms.Message;
import javax.jms.TextMessage;

/*
 * Il est ncessaire de crer l'utilisateur anonymous ou d'adpater le code ci-dessous.
 * Il faut aussi adapter le port d'coute de Joram si ce n'est pas le bon, et ventuellement
 * changer le nom de la queue si vous souhaitez rutiliser une queue existante.
 * 
 * Compilation:
 * javac -cp "ow2-jms-2.0-spec.jar;joram-assembly-client-jms.jar" .\Test.java
 * 
 * Execution:
 * java -Dorg.objectweb.joram.keystore=./joram_ks -Dorg.objectweb.joram.keystorepass=jorampass -cp "ow2-jms-2.0-spec.jar:joram-assembly-client-jms.jar:." Test
 */

public class Test {

  public static void main(String[] args) throws Exception {
    ConnectionFactory cf = TcpConnectionFactory.create("localhost", 16010, "org.objectweb.joram.client.jms.tcp.ReliableSSLTcpClient");
//    ConnectionFactory cf = TcpConnectionFactory.create("localhost", 16010);

    Connection cnx = cf.createConnection("anonymous", "anonymous");
    Session session = cnx.createSession(false, Session.AUTO_ACKNOWLEDGE);
    Queue dest = session.createQueue("queue");
    MessageProducer producer = session.createProducer(dest);
    MessageConsumer consumer = session.createConsumer(dest);
    cnx.start();

    TextMessage msg1 = session.createTextMessage("Test..");
    producer.send(msg1);
    Message msg2 = consumer.receive();
    if (msg2 instanceof TextMessage)
      System.out.println("Msg received: " + ((TextMessage) msg2).getText());
    
    cnx.close();
  }

}
